//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 9-1 #1
//
// Enter E for entry mode, S for search mode. In entry mode, asks user for a
// part number (int16), row number (int8), shelf ID (A-Z) and bin number
// (int16), and saves the data in the next available entry in an array of 
// structures. In search mode, asks user for a part number, and outputs the
// row, shelf and bin number.
//
//////////////////////////////////////////////////////////////////////////////

#include <E3.h>

#define SIZE 5

struct{
   int16 part;
   int8 row;
   char shelf;
   int16 bin;
} parts[SIZE];

int enteredParts=0;

void entry(void);
void search(void);

void main(void){
   
   int cmd;
   
   while(TRUE)
   {
      do{
         printf("\r\n\r\nEnter E or S: ");
         cmd = toupper(getc());
      }while((cmd!='E') && (cmd!='S'));

      if(cmd=='E')
         entry();
      else
         search();      
   }
   
   for(;;);
}

void entry(void){
   printf("\r\nEnter Part Number: ");
   parts[enteredParts].part = get_long_usb();
   
   printf("\r\nEnter Row Number: ");
   parts[enteredParts].row = get_int_usb();
   
   printf("\r\nEnter Shelf Character: ");
   parts[enteredParts].shelf = toupper(usb_cdc_getc());
   printf("%c", parts[enteredParts].shelf);

   printf("\r\nEnter Bin Number: ");
   parts[enteredParts].bin = get_long_usb();
   
   printf("\r\n%lu %u %c %lu", parts[enteredParts].part, parts[enteredParts].row, 
      parts[enteredParts].shelf, parts[enteredParts].bin);
      
   enteredParts++;
}

void search(void){
   int16 part, i;

   printf("\r\nEnter Part Number to search for: ");
   part = get_long_usb();
   
   for(i=0; i<enteredParts; i++)
   {
      if(parts[i].part == part)
      {
         printf("\r\nPart => %lu, Row=> %u, Shelf => %c, Bin => %lu", 
            parts[i].part, parts[i].row, parts[i].shelf, parts[i].bin);
         
         break;
      }
   }
}


